package com.aitrainer.api.controller

import com.aitrainer.api.model.ExercisePlanDetail
import com.aitrainer.api.model.ExerciseType
import com.aitrainer.api.repository.ExercisePlanDetailRepository
import org.slf4j.LoggerFactory
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*
import javax.validation.Valid

@RestController
@RequestMapping("/api")
class ExercisePlanDetailController( private val exercisePlanDetailRepository: ExercisePlanDetailRepository) {
    private val logger = LoggerFactory.getLogger(javaClass)

    @PostMapping("/exercise_plan_detail")
    fun createNewExercisePlanDetail(@Valid @RequestBody exercisePlanDetail: ExercisePlanDetail): ResponseEntity<ExercisePlanDetail> {
        logger.info("Create new exercise plan: $exercisePlanDetail")
        return ResponseEntity.ok().body(exercisePlanDetailRepository.save(exercisePlanDetail))
    }

    @GetMapping("/exercise_plan_detail/last/{customerId}")
    fun getExercisePlanByCustomerId(@PathVariable(value = "customerId") customerId: Long): ResponseEntity<List<ExercisePlanDetail>> {
        val list: List<ExercisePlanDetail> = exercisePlanDetailRepository.getLastExercisePlanDetail(customerId)
        logger.info("-- getExercisePlanByCustomerId id: $customerId -- $list")
        return ResponseEntity.ok().body(list)
    }
}