package com.aitrainer.api.model

import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*

@Entity
data class ExercisePlan(
        @get: NonNull var customerId: Long = 0,
        @get: NonNull var name: String? = null,
        @get: NonNull var description: String? = null,
        @get: NonNull var private: Boolean = false,
        @get: NonNull var dateAdd: String? = null
) {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var exercisePlanId: Long = 0



    @OneToMany(fetch = FetchType.EAGER, mappedBy = "exercisePlan")
    @Fetch(value = FetchMode.SUBSELECT)
    val planDetailList: List<ExercisePlanDetail> = mutableListOf<ExercisePlanDetail>()
}