package com.aitrainer.api.model

import com.fasterxml.jackson.annotation.JsonIgnore
import org.springframework.lang.NonNull
import javax.persistence.*

@Entity
data class ExercisePlanDetail (
    @get: NonNull var exerciseTypeId: Long = 0,
    @get: NonNull var serie: Int = 0,
    @get: NonNull var repeats: Int = 0,
    @get: NonNull var weightEquation: String? = "",

    @ManyToOne(fetch = FetchType.EAGER, optional = false)
    @JoinColumn(name = "exercisePlanId", nullable = false)
    @JsonIgnore
    val exercisePlan: ExercisePlan? = null
) {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    val exercisePlanDetailId: Long = 0
}