package com.aitrainer.api.test

import com.aitrainer.api.model.ExercisePlan
import com.aitrainer.api.model.ExercisePlanDetail
import com.aitrainer.api.repository.ExercisePlanDetailRepository
import org.junit.jupiter.api.Test
import org.junit.jupiter.api.TestInstance
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import kotlin.test.assertEquals

@SpringBootTest
@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class ExercisePlanDetailTest {
    private val logger = LoggerFactory.getLogger(javaClass)

    @Autowired
    private lateinit var exercisePlanDetailRepository: ExercisePlanDetailRepository

    @Test
    fun testInsert() {
        val plan = ExercisePlan(

        )
        plan.exercisePlanId = 6;

        val planDetail = ExercisePlanDetail(
                exerciseTypeId = 41,
                serie = 3,
                repeats = 12,
                weightEquation = "50",
                exercisePlan = plan
        )
        val savedDetail: ExercisePlanDetail = exercisePlanDetailRepository.save(planDetail)
        assertEquals(savedDetail.repeats, 12)
        assertEquals(savedDetail.weightEquation, "50")
        exercisePlanDetailRepository.delete(savedDetail)
    }

    @Test
    fun testGetLastExercisePlanDetail() {
        val exercisePlanDetailList: List<ExercisePlanDetail> = exercisePlanDetailRepository.getLastExercisePlanDetail(90)
        logger.info(" ****** list: $exercisePlanDetailList")
        assertEquals(exercisePlanDetailList.size, 2)

        val exercisePlanDetail: ExercisePlanDetail = exercisePlanDetailList[0]
        assertEquals(exercisePlanDetail.weightEquation, "40")
    }
}

