package com.aitrainer.api.test

import com.aitrainer.api.model.Exercises
import com.aitrainer.api.repository.ExercisesRepository
import org.junit.jupiter.api.Test
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
class ExerciseTest {

    @Autowired
    private lateinit var exerciseRepository: ExercisesRepository

    @Test
    fun testGet() {
        var id: Long = 1

        val exercises: List<Exercises> = exerciseRepository.getAllByCustomerId( id )
        assertEquals( exercises[0].quantity, 12.2)

        id = 100000
        val exercises2: List<Exercises> = exerciseRepository.getAllByCustomerId( id )

        assertEquals( exercises2.size, 0)
    }

    @Test
    fun testInsert() {
        var exercise = Exercises(
            exerciseTypeId = 3,
            customerId = 11,
            quantity = 100.0,
            dateAdd = "2020-05-13 04:32:00",
            unit = "repeat",
            unitQuantity = 30.0,
            restTime = null
        )
        var exerciseNew = exerciseRepository.save(exercise)
        assertTrue(exerciseNew.exerciseId > 2)
        exerciseRepository.delete(exercise)

        exercise = Exercises(
                exerciseTypeId = 40,
                customerId = 11,
                quantity = 32.5,
                dateAdd = "2020-07-05 04:32:00",
                unit = "repeat",
                unitQuantity = 32.6,
                restTime = null
        )
        exerciseNew = exerciseRepository.save(exercise)
        assertTrue(exerciseNew.exerciseId > 3)
        exerciseRepository.delete(exercise)
    }
}